#include "spdlog.hpp"
#include "spdlog_qt.hpp"

#include <QCoreApplication>

namespace myx {

namespace log {

void spdlog_qt_message_handler( QtMsgType type, const QMessageLogContext& context, const QString& qMsg )
{
	if ( !defaultLogger.logger() )
	{
		return;
	}
	Q_UNUSED( context )

	const char* msg = qMsg.toUtf8().constData();

	switch ( type )
	{
	case QtDebugMsg:
		defaultLogger.logger()->debug( msg );
		break;
	case QtInfoMsg:
		defaultLogger.logger()->info( msg );
		break;
	case QtWarningMsg:
		defaultLogger.logger()->warn( msg );
		break;
	case QtCriticalMsg:
		defaultLogger.logger()->critical( msg );
		break;
	case QtFatalMsg:
		defaultLogger.logger()->critical( "FATAL: %s", msg );
		QCoreApplication::exit( 1 );
		break;
	}
}  // messageHandler

} // namespace log

} // namespace myx
